Attribute VB_Name = "Module1"
Option Explicit

Private strPermutation As String
Private strChars As String
Private ArrayPos() As Long
Private ArrayPosPointer As Long
Private strResult() As String
Private lngCount As Long
 
Public Function RecursivePermutation(ByVal n As Long) As Long()

Dim retVal() As Long
Dim i As Long
Dim j As Long

If n < 1 Then
    ReDim retVal(1 To 1, 1 To 1)
    RecursivePermutation = retVal
    Exit Function
End If

If n = 1 Then
    ReDim retVal(1 To 1, 1 To 1)
    retVal(1, 1) = 1
    RecursivePermutation = retVal
    Exit Function
End If

If n > 26 Then
    ReDim retVal(0 To 0, 0 To 0)
    RecursivePermutation = retVal
    Debug.Print "n out of range!"
    Exit Function
End If

strPermutation = ""
strChars = ""
ArrayPosPointer = 0
lngCount = 0
ReDim strResult(0 To 0)

For i = 1 To n
    strChars = strChars & Chr$(64 + i)
Next

ArrayPosPointer = -1
ReDim ArrayPos(Len(strChars) - 1)
Call Permutation(0)

ReDim retVal(1 To lngCount, 1 To n)

For i = 1 To lngCount
    For j = 1 To n
        retVal(i, j) = Asc(Mid(strResult(i), j, 1)) - 64
    Next
Next

RecursivePermutation = retVal
  
End Function
 
Private Sub Permutation(intX As Long)

Dim i As Long

ArrayPosPointer = ArrayPosPointer + 1
ArrayPos(intX) = ArrayPosPointer

If ArrayPosPointer = Len(strChars) Then
    strPermutation = ""
    
    For i = 0 To UBound(ArrayPos)
        strPermutation = strPermutation & Mid$(strChars, ArrayPos(i), 1)
    Next
    
    lngCount = lngCount + 1
    
    ReDim Preserve strResult(lngCount)
    strResult(lngCount) = strPermutation
Else
    For i = 0 To Len(strChars) - 1
        If ArrayPos(i) = 0 Then Call Permutation(i)
    Next
End If

ArrayPosPointer = ArrayPosPointer - 1
ArrayPos(intX) = 0
  
End Sub
